testFlipInsight.directive('uiScanAccordion', function($timeout) {
return {
  scope:{
    myAccordionData: '=uiScanAccordion'
  },
  templateUrl: 'app/directives/scan-accordian/scan-accordian-template.html',
  link: function(scope, element) {
    scope.$watch('myAccordionData', function() {
      scope.myData = scope.myAccordionData;
      console.log(scope.myAccordionData);
      scope.generateAccordion();
    });


    scope.generateAccordion = function() {
      $timeout(function() {   //<--- used $timeout to make sure ng-repeat is REALLY finished
        var accordion = null;
        $( function() {
        	accordion = $('#accordion').accordion({
        		collapsible: true,
            heightStyle: "content",
            header: "> div > h3",

        		beforeActivate: function(event, ui) {
        			 // The accordion believes a panel is being opened
        			if (ui.newHeader[0]) {
        				var currHeader  = ui.newHeader;
        				var currContent = currHeader.next('.ui-accordion-content');
        			 // The accordion believes a panel is being closed
        			} else {
        				var currHeader  = ui.oldHeader;
        				var currContent = currHeader.next('.ui-accordion-content');
        			}
        			 // Since we've changed the default behavior, this detects the actual status
        			var isPanelSelected = currHeader.attr('aria-selected') == 'true';

        			 // Toggle the panel's header
        			currHeader.toggleClass('ui-corner-all',isPanelSelected).toggleClass('accordion-header-active ui-state-active ui-corner-top',!isPanelSelected).attr('aria-selected',((!isPanelSelected).toString()));

        			// Toggle the panel's icon
        			currHeader.children('.ui-icon').toggleClass('ui-icon-triangle-1-e',isPanelSelected).toggleClass('ui-icon-triangle-1-s',!isPanelSelected);

        			 // Toggle the panel's content
        			currContent.toggleClass('accordion-content-active',!isPanelSelected)
        			if (isPanelSelected) { currContent.slideUp(); }  else { currContent.slideDown(); }

        			return false; // Cancels the default action
        		}
        	});

        	delete($.ui.accordion.prototype._keydown);

        });
      });
     }
   },
   controller: ['$scope', '$rootScope', 'TestProjectService', function ($scope, $rootScope, TestProjectService) {
     // Load the custom types for project
     TestProjectService.getCustomTemplateFunctionNamesForProject($rootScope.serviceDetails.project_id)
     .then (function(data, status, headers, config) {
       $scope.projectCustomTemplates = data.data;
     }, function(data, status, headers, config) {

     });

      $scope.addObject = function()
      {
          $scope.myAccordionData.push({
            name: 'Edit me',
            objectType: 'Link',
            parameters: []
          });

          $timeout(function() {
            $('#accordion').accordion("refresh");
          });
      }

      $scope.addParameter = function(item)
      {
          item.parameters.push({
              paramValue: '',
              paramType: 'XPath',
              confidence: 1
          });
      }

      $scope.moveUp = function(item, identifier)
      {
        move(item.parameters, item.parameters.indexOf(identifier), -1);
      }

      $scope.moveDown = function(item, identifier)
      {
        move(item.parameters, item.parameters.indexOf(identifier), 1);

      }

      function move(array, index, delta) {
          var newIndex = index + delta;
          if (newIndex < 0 || newIndex == array.length) return; //Already at the top or bottom.
          var indexes = [index, newIndex].sort((a, b) => a - b); //Sort the indixes (fixed)
          array.splice(indexes[0], 2, array[indexes[1]], array[indexes[0]]); //Replace from lowest index, two elements, reverting the order
      }

      $scope.removeItem = function(item)
      {
        $scope.myAccordionData = removeItemFromArray($scope.myAccordionData, item);
      }

      $scope.removeIdentifier = function(item, id) {
        item.parameters = removeItemFromArray(item.parameters, id);
      }

      $scope.computeIdentiferWarnings = function(object) {
        var allWarning = true;
        for (var i = 0; i < object.parameters.length; i++) {
          allWarning = allWarning && object.parameters[i].identiferWarning;
        }

        return allWarning;
      }

      function removeItemFromArray(arr) {
          var what, a = arguments, L = a.length, ax;
          while (L > 1 && arr.length) {
              what = a[--L];
              while ((ax= arr.indexOf(what)) !== -1) {
                  arr.splice(ax, 1);
              }
          }
          return arr;
      }
   }]
  }
})
