testFlipInsight.directive('uiAccordion', function($timeout) {
return {
  scope:{
    myAccordionData: '=uiAccordion'
  },
  templateUrl: 'app/directives/accordian-template.html',
  link: function(scope, element) {
    scope.$watch('myAccordionData', function() {
      scope.myData = scope.myAccordionData;
      generateAccordion();

    });

    var generateAccordion = function() {
      $timeout(function() {   //<--- used $timeout to make sure ng-repeat is REALLY finished
        var accordion = null;
        $( function() {
        	accordion = $('#accordion').accordion({
        		collapsible: true,

            header: "> div > h3",

        		beforeActivate: function(event, ui) {
        			 // The accordion believes a panel is being opened
        			if (ui.newHeader[0]) {
        				var currHeader  = ui.newHeader;
        				var currContent = currHeader.next('.ui-accordion-content');
        			 // The accordion believes a panel is being closed
        			} else {
        				var currHeader  = ui.oldHeader;
        				var currContent = currHeader.next('.ui-accordion-content');
        			}
        			 // Since we've changed the default behavior, this detects the actual status
        			var isPanelSelected = currHeader.attr('aria-selected') == 'true';

        			 // Toggle the panel's header
        			currHeader.toggleClass('ui-corner-all',isPanelSelected).toggleClass('accordion-header-active ui-state-active ui-corner-top',!isPanelSelected).attr('aria-selected',((!isPanelSelected).toString()));

        			// Toggle the panel's icon
        			currHeader.children('.ui-icon').toggleClass('ui-icon-triangle-1-e',isPanelSelected).toggleClass('ui-icon-triangle-1-s',!isPanelSelected);

        			 // Toggle the panel's content
        			currContent.toggleClass('accordion-content-active',!isPanelSelected)
        			if (isPanelSelected) { currContent.slideUp(); }  else { currContent.slideDown(); }

        			return false; // Cancels the default action
        		}
        	});

        	delete($.ui.accordion.prototype._keydown);

        });
       });
     }
   },
   controller: ['$scope', function ($scope) {
      $scope.code_action = Code_Actions;

      $scope.downloadImage = function(item)
      {
        screenShotCapture.saveScreenshot(item.action_img);
      }

      $scope.editItemText = function(item)
      {
          item.editMode = true;

          item.englishEdit = item.english;
      }

      $scope.saveItemText = function(item)
      {
          item.editMode = false;

          item.english = item.englishEdit;
      }


      $scope.removeItem = function(item)
      {
        $scope.myData = removeItemFromArray($scope.myData, item);
      }

      function removeItemFromArray(arr) {
          var what, a = arguments, L = a.length, ax;
          while (L > 1 && arr.length) {
              what = a[--L];
              while ((ax= arr.indexOf(what)) !== -1) {
                  arr.splice(ax, 1);
              }
          }
          return arr;
      }
   }]
  }
})
