testFlipInsight.controller('loginController', ['$rootScope','$scope', '$state', '$interval', '$timeout', '$stateParams', '$http', 'authService', 'TenantService', 'AUTH_CONFIG', 'API_URL', 'toastr',
	function($rootScope, $scope, $state, $interval, $timeout, $stateParams, $http, authService, TenantService, AUTH_CONFIG, API_URL, toastr) {
		  $scope.error = false;
		  $scope.errorMessage = "";
			$scope.nativeAuth = AUTH_CONFIG.nativeAuth;
			$scope.regURL = API_URL.SignupURL;

			// Set defaults from previous
			if ($rootScope.serviceDetails != null) {
				if ($rootScope.serviceDetails.API_URL != null)
					$scope.api = $rootScope.serviceDetails.API_URL;

					$rootScope.serviceDetails.project_id = null;

					$rootScope.serviceDetails.release_id = null;

					$rootScope.serviceDetails.workspace = null;

					if ($rootScope.serviceDetails.username != null)
						$scope.username = $rootScope.serviceDetails.username;
			}


		  if ($stateParams.errorMessage) {
				$scope.error = true;
			  $scope.errorMessage = $stateParams.errorMessage;
 		  }


			$scope.login = function(api, username, password) {

					if ($scope.nativeAuth) {
						API_URL.URL = api;
						$rootScope.serviceDetails.API_URL = api;

						console.log("API URL set as " + api);
					}

					console.log("Username set as " + username);

					$rootScope.serviceDetails.username = username;

         authService.login(api, username,password, loginResult);
      }

      $scope.help = function() {
				var newURL = "https://curiositysoftware.ie/vip-knowledge-base/";

				chrome.tabs.create({ url: newURL });
      }

			$scope.register = function() {
				var newURL = $scope.regURL;

				chrome.tabs.create({ url: newURL });
			}

      function loginResult(error, authResult)
      {
         if (error) {
           // Display error message
					 toastr.error("You have entered an invalid username or password.", "User password combination not recognised");
         } else {
								chrome.storage.local.set({ service_settings: $rootScope.serviceDetails });

								if (authService.getTenantsByToken(authResult.idToken).length == 0) {
									toastr.error("You have no workspaces available. Please create a workspace before signing in.", "No workspaces available");

									return;
								}

                authService.setSession(authResult);

								var authCheck = $interval(function() {
									if (authService.isAuthenticated() && authResult.idToken === authService.getIdToken()) {
			              		$interval.cancel(authCheck);

												$timeout( function() {
													$state.go('projectContext');
												}, 800 );
										}
									}, 500);
         }
      }
}]);
