testFlipInsight
    .directive('confirmPageCollection', ['$rootScope', '$compile', '$ngBootbox', 'toastr', 'automationFrameworkService', 'folderService', 'fileService', 'pageCollectionService',
    function($rootScope, $compile, $ngBootbox, toastr, automationFrameworkService, folderService, fileService, pageCollectionService)
    {
      return {
        restrict: 'E',
        permissions: '@',
        replace: true,
        scope: {confirmPageCollectionDir:'=confirmPageCollectionDir'},
        link: function($scope, element, attrs)
        {
          $scope.confirmPageCollectionDir = {};

          $scope.confirmPageCollectionDialog = {
               templateUrl: 'app/pages/recorder/dialogs/confirmPageCollection.html',
               scope: $scope,
               size: 'large',
               closeButton: false,
           };
		   
		   $scope.save = function ()
		   {
				$('.container').css({'width': 340});
				$('.container').css({'width': ""});
				$('.container').css({'height': 300});
				$('.container').css({'height': ""});

				$scope.upload();
          		$ngBootbox.hideAll();

			}

		   $scope.close = function ()
		   {
				 $('.container').css({'width': 340});
				 $('.container').css({'width': ""});
				 $('.container').css({'height': 300});
				 $('.container').css({'height': ""});


				 $scope.cancel();			   
          		$ngBootbox.hideAll();

			 }

          $scope.confirmPageCollectionDir.open = function(pageObject, releaseId)
          {
            $scope.pageObject = pageObject;
            $scope.releaseId = releaseId;

            $scope.ColnName = pageObject.name;

      			var curObj = {};
      			curObj.name = "Home";
      			curObj.id = -1;
      			curObj.releaseId = releaseId;
      			curObj.type = "Folder";
      			curObj.expanded = true;
      			curObj.childrenLoaded = true;
      			curObj.children = [];

      			$scope.basicTree = [curObj];

            automationFrameworkService.getAutomationFrameworkItems()
      			.then (function(data, status, headers, config) {
      				$scope.frameworkCollection = data.data;
      			}, function(data, status, headers, config) {

      			});

      			folderService.getRootFoldersByRelease(releaseId)
      			.then (function(data, status, headers, config) {
      				addFolderObjects(releaseId, curObj.children, data.data);
      			}, function(data, status, headers, config) {

      			});

      			fileService.getRootFilesByReleaseId(releaseId)
      			.then (function(data, status, headers, config) {
      				addFileObjects(null, releaseId, curObj.children, data.data);
      			}, function(data, status, headers, config) {

      			});

      			$scope.basicOptions = {
        				showIcon: true,
        				onSelectNode : function (node) {
        						$scope.selectedNode = node;
        				},
        				onExpandNode : function (node) {
        					if (node.childrenLoaded == false) {
        						node.children = [];

        						folderService.getSubFolders(node.id)
        						.then (function(data, status, headers, config) {
        							addFolderObjects(node.releaseId, node.children, data.data);
        						}, function(data, status, headers, config) {

        						});

        						fileService.getFilesInFolder(node.id)
        						.then (function(data, status, headers, config) {
        							addFileObjects(node, node.releaseId, node.children, data.data);
        						}, function(data, status, headers, config) {

        						});
        					}
        				}
        			};

              $('.container').css({'width': 500});
              $('.container').css({'height': 600});

              $ngBootbox.customDialog($scope.confirmPageCollectionDialog);
            }

        			function addFolderObjects (releaseId, list, data) {
        				for(var i = 0; i < data.length; i++) {

        					var curObj = {};

        					curObj.name = data[i].folderName;
        					curObj.id = data[i].id;
        					curObj.releaseId = releaseId;
        					curObj.type = "Folder";
        					curObj.expanded = false;
        					curObj.childrenLoaded = false;
        					curObj.children = [{id: -1, name: "Loading..."}];

        					list.unshift(curObj);
        				}
        			}

      			function addFileObjects(node, releaseId, list, data) {
      				for(var i = 0; i < data.length; i++) {
      					var curObj = {};

      					curObj.name = data[i].fileName;
      					curObj.id = data[i].id;
      					curObj.releaseId = releaseId;
      					curObj.image = "app/directives/angular-tree-widget/img/file.png";
      					curObj.type = "File";

      					if (node != null)
      						curObj.parent = node.id;

      					curObj.fileType = data[i].fileType;
      					curObj.resourceId = data[i].fileResourceId;

      					if (data[i].fileType === "PageObject") {
      						curObj.disabled = false;
      						list.push(curObj);

      					} else {
      						curObj.disabled = true;
      					}

      					curObj.children = [];
      				}
      			}

          	$scope.upload = function() {
          		if ($scope.screenshot) {
          			chrome.tabs.captureVisibleTab(null, {format: "jpeg", quality: 3}, function(data) {
          				$scope.pageObject.image = data.replace(/^data:image\/(png|jpg|jpeg);base64,/, '');

          				uploadObject();
          			});
          		} else {
          			uploadObject();
          		}
          	};

          	function uploadObject()
          	{
          		// Strip bad characters
          		$scope.pageObject.name = $scope.ColnName.replace(/[^a-z0-9 ]+/gi, "");
          		for (var i = 0; i < $scope.pageObject.pageObjects.length; i++) {
          			var pObject = $scope.pageObject.pageObjects[i];
          			pObject.name = stringTrim(pObject.name, 100);

          			if (pObject.parameters != null) {
          				for (var j = 0; j < pObject.parameters.length; j++) {
          					if (pObject.parameters[j].name == null)
          						continue;

          					pObject.parameters[j].name = stringTrim(pObject.parameters[j].name, 100);
          				}
          			}

          			if (pObject.screenSize != null) {
          				$scope.pageObject.screenCoords = pObject.screenSize;
          			}
          		}

          		if ($scope.frameworkId != null) {
          			$scope.pageObject.frameworkId = $scope.frameworkId;
          		}

          		var merge = false;
          		var folderId = null;
          		if ($scope.selectedNode == null || $scope.selectedNode.type === "Folder") {
          			if ($scope.selectedNode != null && $scope.selectedNode.id >= 0)
          				folderId = $scope.selectedNode.id;

          			// Get the object
          			pageCollectionService.getPageCollectionsByNameAndRelease($scope.pageObject.name, $scope.releaseId)
          			.then(function (data, status, headers, config) {
          				if (data.data.length > 0) {
          					// Ask user merge or cancel
          					$ngBootbox.confirm({message: 'All page objects must have a unique name. Page object with ID (' + data.data[0].id + ') found with name "' + $scope.pageObject.name + '"',
          						title: 'A page object with the same name has been found',
          						closeButton: false,
          						buttons: {
          					         confirm: {
          					             label: 'Perform Merge',
          					             className: 'btn-success'
          					         },
          					         cancel: {
          					             label: 'Cancel',
          					             className: 'btn-danger'
          					         }
          					     }
          					})
          			    .then(function() {
          						performMerge($scope.releaseId, $scope.pageObject, data.data[0].id);
          			    }, function() {

          			    });

          				} else {
          					pageCollectionService.savePageCollectionAndCreateModule(folderId, $scope.releaseId, $scope.pageObject, $scope.createModel)
          					.then(function (data, status, headers, config) {
          							toastr.success('Page Object uploaded successfully with ID (' + data.data.id + ').',"Upload Complete");

          					},function (erdata, status, header, config) {
          						toastr.error(erdata.data.message,"Error uploading page collection");

           					  console.log("Error uploading page collection. " + "Status: (" + status + ") Response: " + JSON.stringify(erdata));
          					});
          				}
          			},function (erdata, status, header, config) {
          			});
          		} else {
          			performMerge($scope.releaseId, $scope.pageObject, $scope.selectedNode.resourceId);
          		}
          	}

          	function performMerge(releaseId, pageObject, existingId)
          	{
          			pageCollectionService.getPageCollection(existingId)
          			.then(function (data, status, headers, config) {
          				// Ask the user how to merge the two
          				var existingMod = data.data;

          				var newMod = pageObject;

          				// Try to find matching ID
          				var existingModeObjects = {};
          				for (var i = 0 ; i < existingMod.pageObjects.length; i++) {
          					existingModeObjects[existingMod.pageObjects[i].name] = existingMod.pageObjects[i].id;
          				}

          				for (var i = 0 ; i < newMod.pageObjects.length; i++) {
          					if (existingModeObjects[newMod.pageObjects[i].name] != null) {
          							newMod.pageObjects[i].mapId = existingModeObjects[newMod.pageObjects[i].name].toString();
          					} else {
          							newMod.pageObjects[i].mapId = '-1';
          					}
          				}

                  $scope.mergePageCollectionDir.open(existingMod, newMod, $scope.selectedNode, releaseId);

          			},function (data, status, header, config) {
           				 alert("Error getting page collection. " + "Status: (" + status + ") Response: " + JSON.stringify(data));

          				 console.log(data);
          			});
          	}

          	function stringTrim  (str, length) {
				if (str == null)
					return "";
				
				return str.length > length ? str.substring(0, length) : str;
          	}

          	$scope.cancel = function() {
          		$ngBootbox.hideAll();
          	};
        }
      }
    }
  ])
