testFlipInsight
    .directive('confirmSessionCollection', ['$rootScope', '$compile', '$ngBootbox', 'toastr', 'automationFrameworkService', 'folderService', 'fileService', 'pageCollectionService', 'journeyPoolService', 'JourneyService', 'TestSessionService', 'TestSessionRRPairService', 'TestSessionConsoleService', 'TestSessionActivityService',
    function($rootScope, $compile, $ngBootbox, toastr, automationFrameworkService, folderService, fileService, pageCollectionService, journeyPoolService, JourneyService, TestSessionService, TestSessionRRPairService, TestSessionConsoleService, TestSessionActivityService)
    {
      return {
        restrict: 'E',
        permissions: '@',
        replace: true,
        scope: {confirmSessionCollectionDir:'=confirmSessionCollectionDir'},
        link: function($scope, element, attrs)
        {
          $scope.confirmSessionCollectionDir = {};

          $scope.confirmSessionCollectionDialog = {
               templateUrl: 'app/pages/recorder/dialogs/confirmSessionDialog.html',
               scope: $scope,
               size: 'large',
               closeButton: false,
               buttons: {
                   success: {
                     label: "<span class=\"fa fa-save\"> </span> " + 'Save',
                     className: "btn-success btn btn-sm",
                     callback: function () {
                       $('.container').css({'width': 340});
                       $('.container').css({'width': ""});

                       return $scope.upload();
                     }
                   },
                   warning: {
                       label: "<span class=\"fa fa-ban\"> </span> " + 'Cancel',
                       className: "btn-warning btn btn-sm",
                       callback: function () {
                         $('.container').css({'width': 340});
                         $('.container').css({'width': ""});
                         $scope.cancel();
                       }
                   }
               }
           };

          $scope.confirmSessionCollectionDir.open = function(projectId, releaseId, testActivity, recorderRRPairs, recorderConsole)
          {
            $scope.releaseId = releaseId;
            $scope.testActivity = testActivity;
            $scope.recorderRRPairs = recorderRRPairs;
            $scope.recorderConsole = recorderConsole;

            $scope.journeyOption = 'New_Journey';
            $scope.detail = {};

            var curObj = {};
            curObj.name = "Home";
            curObj.id = -1;
            curObj.releaseId = $scope.releaseId;
            curObj.type = "Folder";
            curObj.expanded = true;
            curObj.childrenLoaded = true;
            curObj.children = [];

            $scope.basicTree = [curObj];

            folderService.getRootFoldersByRelease($scope.releaseId)
            .then (function(data, status, headers, config) {
              addFolderObjects($scope.releaseId, curObj.children, data.data);
            }, function(data, status, headers, config) {

            });

            fileService.getRootFilesByReleaseId($scope.releaseId)
            .then (function(data, status, headers, config) {
              addFileObjects($scope.releaseId, curObj.children, data.data);
            }, function(data, status, headers, config) {

            });

            $scope.basicOptions = {
              showIcon: true,
              onSelectNode : function (node) {
                $scope.selectedNode = node;
              },
              onExpandNode : function (node) {
                if (node.childrenLoaded == false) {
                  node.children = [];

                  folderService.getSubFolders(node.id)
                  .then (function(data, status, headers, config) {
                    addFolderObjects(node.releaseId, node.children, data.data);
                  }, function(data, status, headers, config) {
                    console.log(data);
                  });

                  fileService.getFilesInFolder(node.id)
                  .then (function(data, status, headers, config) {
                    addFileObjects(node.releaseId, node.children, data.data);
                  }, function(data, status, headers, config) {
                    console.log(data);
                  });
                }
              }
            };

            $('.container').css({'width': 500});
            $ngBootbox.customDialog($scope.confirmSessionCollectionDialog);
          }


          function addFolderObjects (releaseId, list, data) {
            for(var i = 0; i < data.length; i++) {

              var curObj = {};

              curObj.name = data[i].folderName;
              curObj.id = data[i].id;
              curObj.releaseId = releaseId;
              curObj.type = "Folder";
              curObj.expanded = false;
              curObj.childrenLoaded = false;
              curObj.children = [{id: -1, name: "Loading..."}];

              list.unshift(curObj);
            }
          }

          function addFileObjects(releaseId, list, data) {
            for(var i = 0; i < data.length; i++) {
              var curObj = {};

              curObj.name = data[i].fileName;
              curObj.id = data[i].id;
              curObj.releaseId = releaseId;
              curObj.image = "app/directives/angular-tree-widget/img/file.png";
              curObj.type = "File";
              curObj.fileType = data[i].fileType;
              curObj.resourceId = data[i].fileResourceId;

              if (data[i].fileType === "TestInsightsPool") {
                curObj.disabled = false;
                list.push(curObj);

              } else {
                curObj.disabled = true;
              }

              curObj.children = [];
            }
          }

           /* Upload session */
           $scope.upload_session = function () {
             if ($scope.ColnName == null || $scope.ColnName == "") {
               toastr.error("Please enter a name for the recording.", "Error");
               return false;
             }

             if ($scope.selectedNode == null || $scope.selectedNode.type === "Folder") {
               if ($scope.selectedNode != null && $scope.selectedNode.id >= 0) {
                  // Create a new pool
                  journeyPoolService.createPool($scope.releaseId, $scope.selectedNode.id, $scope.ColnName)
                  .then (function(data, status, headers, config) {
                    createNewJourney($scope.releaseId, data.data.id, createNewSession);
                  }, function(data, status, headers, config) {
                    alert(JSON.stringify(data.data));
                  });

               } else {
                 // Create a new pool
                 journeyPoolService.createPool($scope.releaseId, null, $scope.ColnName)
                 .then (function(data, status, headers, config) {
                   createNewJourney($scope.releaseId, data.data.id, createNewSession);
                 }, function(data, status, headers, config) {
                   alert(JSON.stringify(data.data));
                   console.log(data);
                 });
               }
             } else if ($scope.selectedNode.fileType === "TestInsightsPool") {
               createNewJourney($scope.releaseId, $scope.selectedNode.resourceId, createNewSession);
             } else {
               alert($scope.selectedNode.fileType);
             }

             return true;
          };

          function createNewJourney(release_id, poolId, callBack)
          {
              var obj = {};
              obj.release = release_id;
              obj.title = $scope.ColnName;
              obj.description = $scope.ColnName;
              obj.journeyPool = poolId,
              obj.sourceLocation = 'TestInsight Recorder';

              JourneyService.createJourney(obj)
              .then(function (data, status, headers, config) {
                callBack(release_id, data.data.id, uploadActivities);
              },function (data, status, header, config) {
                toastr.error('Unable to create a new journey. ' + JSON.stringify(data), "Error creating new journey.");

                console.log(data);
              });

          }

          function createNewSession(release_id, journey_id, callBack)
          {
              var timeStamp =  (new Date().getTime());

              var obj = {};
              obj.journey = journey_id;
              obj.release = release_id;
              obj.title = $scope.ColnName;
              obj.description = $scope.ColnName;
              obj.createdTimestamp = timeStamp;

              TestSessionService.createTestSession(obj)
              .then(function (data, status, headers, config) {
                callBack(data.data.id);
              },function (data, status, header, config) {
                toastr.error('Unable to create a new session. ' + data.message, "Error creating new session.");

                console.log(data);
              });
          }

          function stringTrim  (str, length) {
              return str.length > length ? str.substring(0, length) : str;
          }


          function uploadActivities(sessionId)
          {
            $ngBootbox.hideAll();

            // 1) Upload RR pairs
            var rrList = [];

            for(var rrID in $scope.recorderRRPairs) {
                var rrPair = {};

                var curRRPair = JSON.parse($scope.recorderRRPairs[rrID]);

                if (curRRPair.request == undefined) {
                   continue;
                 }

                rrPair.requestMessage = {};
                rrPair.requestMessage.method = stringTrim(curRRPair.request.method, 40);

                if (curRRPair.request.requestBody != undefined) {
                  rrPair.requestMessage.requestBody = JSON.stringify(curRRPair.request.requestBody.raw);
                } else {
                  rrPair.requestMessage.requestBody = "";
                }
                rrPair.requestMessage.type = stringTrim(curRRPair.request.type, 100);
                rrPair.requestMessage.url = curRRPair.request.url;
                rrPair.requestMessage.requestHeaders = JSON.stringify(curRRPair.request.requestHeaders);

                rrPair.responseMessage = {};
                rrPair.responseMessage.fromCache = curRRPair.response.fromCache;
                rrPair.responseMessage.ip = curRRPair.response.ip;
                rrPair.responseMessage.method = stringTrim(curRRPair.response.method, 100);
                rrPair.responseMessage.statusCode = curRRPair.response.statusCode;
                rrPair.responseMessage.statusLine = stringTrim(curRRPair.response.statusLine, 100);
                rrPair.responseMessage.type = stringTrim(curRRPair.response.type, 100);
                rrPair.responseMessage.url = curRRPair.response.url;
                rrPair.responseMessage.responseHeaders = JSON.stringify(curRRPair.response.responseHeaders);
                rrPair.responseMessage.message = JSON.stringify(curRRPair.response.message);
                rrPair.responseMessage.timeStamp = Math.round(curRRPair.response.timeStamp);

                rrPair.messageDuration = curRRPair.timeToComplete.timeStamp;

                rrPair.session = sessionId;


                rrList.push(rrPair);
            }

            TestSessionRRPairService.saveTestActivityRRPairCollection(rrList)
            .then(function (dataE, status, headers, config) {
            },function (dataE, status, header, config) {
              console.log(dataE);

              alert("error " + JSON.stringify(dataE));
            });

            // 2) Upload console
            for (var i = 0; i < $scope.recorderConsole.length; i++) {
                $scope.recorderConsole[i].session = sessionId;
            }

            TestSessionConsoleService.saveTestActivityConsoleCollection($scope.recorderConsole)
            .then(function (dataE, status, headers, config) {
            },function (dataE, status, header, config) {
              console.log(dataE);

              alert("error " + JSON.stringify(dataE));
            });

            // 3) Upload recording
            var data = [];

            for (var i = 0; i < $scope.testActivity.length; i++) {
              var curElement = $scope.testActivity[i];

              // If current element is new URL after a switch tab event then continue;
              if (i >= 1 && data.length >= 1) {
                if (curElement.code.type === Code_Actions.Event_New_URL) {
                  if (data[data.length - 1].objectInteractionType === Code_Actions.Event_Switch_Tab) {
                      continue;
                  }
                }
              }

              var obj = {};
              obj.session = sessionId;
              obj.actionType = curElement.type;
              obj.actionDescription = curElement.english; // English description
              obj.paramertisedActionDescription = JSON.stringify(curElement.paramEnglish);
              obj.tagName = stringTrim(curElement.tagEnglishName, 100);
              obj.associatedCode = seleniumWebdriverJava.create_snippet($scope.testActivity[i]); // Code
              obj.dateTime = $scope.testActivity[i].time_stamp; // Time
              obj.objectId = curElement.code.elem; // Element ID (xpath)
              obj.objectInteractionType = stringTrim(curElement.code.type, 100);
              obj.objectType = "na"; // TODO - Tag type
              obj.objectValue = curElement.code.value; // Obj value
              obj.pageRef = curElement.url; // Page reference
              obj.pageTitle = curElement.title; // page title
              obj.htmlDOM = curElement.domHTML; // DOM html
              obj.cssDOM = JSON.stringify(curElement.domCSS); // DOM css
              obj.htmlPage = curElement.htmlPage;
              obj.identifiers = curElement.elemIdentifiers;

              obj.associatedCookies = [];

              // Cookies
              for(var key in curElement.cookies){
                  var curCookie = {};

                  curCookie.cookieName = key;
                  curCookie.cookieValue = curElement.cookies[key];

                  obj.associatedCookies.push(curCookie);
              }

              if (curElement.action_img != undefined && curElement.action_img.screenshot != undefined)
                obj.image = curElement.action_img.screenshot.replace(/^data:image\/(png|jpg|jpeg);base64,/, '');

              obj.actionRegion = {};
              if (curElement.action_img != null && curElement.action_img != undefined) {
                obj.actionRegion.viewportStartXPos = parseInt(curElement.action_img.viewportStartXPos);
                obj.actionRegion.viewportStartYPos = parseInt(curElement.action_img.viewportStartYPos);
                obj.actionRegion.viewportWidth = parseInt(curElement.action_img.viewportWidth);
                obj.actionRegion.viewportHeight = parseInt(curElement.action_img.viewportHeight);
                obj.actionRegion.actionLocalXPos = parseInt(curElement.action_img.actionBoundingLocalXPos);
                obj.actionRegion.actionLocalYPos = parseInt(curElement.action_img.actionBoundingLocalYPos);
                obj.actionRegion.actionGlobalXPos = parseInt(curElement.action_img.actionBoundingGlobalXPos);
                obj.actionRegion.actionGlobalYPos = parseInt(curElement.action_img.actionBoundingGlobalYPos);
                obj.actionRegion.globalPageWidth = parseInt(curElement.action_img.globalPageWidth);
                obj.actionRegion.globalPageHeight = parseInt(curElement.action_img.globalPageHeight);

                obj.actionRegion.width = parseInt(curElement.action_img.width);
                obj.actionRegion.height = parseInt(curElement.action_img.height);
              }

              data.push(obj);
            }

            TestSessionActivityService.saveTestActivityCollection(data)
            .then(function (dataE, status, headers, config) {
              toastr.success("Session uploaded successfully.", "Success");

            },function (dataE, status, header, config) {
              toastr.error("Unable to upload session activity. " + data.message, "Error uploading session activity.");

              console.log(dataE);
            });
          }


          $scope.upload = function() {
              return $scope.upload_session();
          };

          $scope.cancel = function() {
            $ngBootbox.hideAll();
          };
        }
      }
    }
  ]);
