testFlipInsight
    .directive('mergePageCollection', ['$rootScope', '$compile', '$ngBootbox', 'toastr', 'automationFrameworkService', 'folderService', 'fileService', 'pageCollectionService',
    function($rootScope, $compile, $ngBootbox, toastr, automationFrameworkService, folderService, fileService, pageCollectionService)
    {
      return {
        restrict: 'E',
        permissions: '@',
        replace: true,
        scope: {mergePageCollectionDir:'=mergePageCollectionDir'},
        link: function($scope, element, attrs)
        {
          $scope.mergePageCollectionDir = {};

          $scope.mergePageCollectionDialog = {
               templateUrl: 'app/pages/recorder/dialogs/mergePageCollection.html',
               scope: $scope,
               size: 'large',
               closeButton: false,
               buttons: {
                   success: {
                     label: "<span class=\"fa fa-save\"> </span> " + 'Save',
                     className: "btn-success btn btn-sm",
                     callback: function () {
                       $('.container').css({'width': 340});
                       $('.container').css({'width': ""});

                       $scope.upload();
                     }
                   },
                   warning: {
                       label: "<span class=\"fa fa-ban\"> </span> " + 'Cancel',
                       className: "btn-warning btn btn-sm",
                       callback: function () {
                         $('.container').css({'width': 340});
                         $('.container').css({'width': ""});

                         $scope.cancel();
                       }
                   }
               }
           };

           $scope.mergePageCollectionDir.open = function(existingMod, newMod, selectedNode, releaseId)
           {
              $scope.existingMod = existingMod;

              $scope.newMod = newMod;

              $scope.selectedNode = selectedNode;

              $scope.releaseId = releaseId;

              $('.container').css({'width': 400});
              $ngBootbox.customDialog($scope.mergePageCollectionDialog);
           }

           $scope.upload = function() {
       				// Create index hash of existing mod
       				$scope.existingModObjHash = {};
       				for (var i = 0; i < $scope.existingMod.pageObjects.length; i++) {
       					$scope.existingModObjHash[$scope.existingMod.pageObjects[i].id] = $scope.existingMod.pageObjects[i];
       				}

       				// Loop over new mod
       				for (var i = 0; i < $scope.newMod.pageObjects.length; i++) {
       					if (parseInt($scope.newMod.pageObjects[i].mapId) >= 0 ) {
       						// Merge the parameters in (ideally reuse the same IDs)
       						var curObj = $scope.existingModObjHash[parseInt($scope.newMod.pageObjects[i].mapId)];

       						curObj.objectType = $scope.newMod.pageObjects[i].objectType;
           				curObj.customObjectType = $scope.newMod.pageObjects[i].customObjectType;

       						curObj.iframeXPath = $scope.newMod.pageObjects[i].iframeXPath;

       						curObj.shadowRoot = $scope.newMod.pageObjects[i].shadowRoot;

       						curObj.parameters = $scope.newMod.pageObjects[i].parameters;

       					} else {
       						// add new object
       						$scope.existingMod.pageObjects.push($scope.newMod.pageObjects[i]);
       					}
       				}

       				var fileParent = null;
       				if ($scope.selectedNode != null)
       					fileParent = $scope.selectedNode.parent;

       				pageCollectionService.savePageCollectionAndCreateModule(fileParent, $scope.releaseId, $scope.existingMod, false)
       				.then (function(data, status, headers, config) {
       					toastr.success("Page Object uploaded successfully.", "Success");

       				},function (erdata, status, header, config) {
       					alert("Error uploading page collection. " + "Status: (" + status + ") Response: " + JSON.stringify(erdata));
       				})
       		}

       		$scope.cancel = function() {
       			$ngBootbox.hideAll();
       		};
         }
       }
     }
   ]);
