testFlipInsight.controller('scanSettingsController', ['$rootScope','$scope', '$state', '$http', 'TestAdminService', 'TestProjectService', 'TestReleaseService', 'TenantService', 'authService', 'API_URL', 'APP_CONFIG',
	function($rootScope, $scope, $state, $http, TestAdminService, TestProjectService, TestReleaseService, TenantService, authService, API_URL, APP_CONFIG)
	{
		$scope.identifierMappings = [];
		$scope.identifierAttributes = [];
		$scope.selectorType = null;
		$scope.customScan = null;
		$scope.searchDepth = 4;
		$scope.objectIndex = null;

		chrome.storage.local.get({
			identifierMaps: [],
			identifierPreferences: [],
			identifierAttrs: [],
			selectorType: null,
			customScan: null,
			searchDepth: 4,
			objectIndex: false
		}, (state) => {
			$scope.identifierMappings = state.identifierMaps;
			$scope.identifierAttributes = state.identifierAttrs;

			$scope.identifierPreferences = [];
			if (state.identifierPreferences != null) {
				for (var i = 0; i < state.identifierPreferences.length; i++) {
					$scope.identifierPreferences.push({value: state.identifierPreferences[i]});
				}
			}

			$scope.selectorType = state.selectorType;
			$scope.customScan = state.customScan;
			$scope.searchDepth = state.searchDepth;
			$scope.objectIndex = state.objectIndex;
		});

		$scope.saveEdit = function()
		{
			var prefs = [];
			if ($scope.identifierPreferences != null) {
				for (var i = 0; i < $scope.identifierPreferences.length; i++) {
					prefs.push($scope.identifierPreferences[i].value);
				}
			}

			chrome.storage.local.set({
				identifierMaps: $scope.identifierMappings,
				identifierAttrs: $scope.identifierAttributes,
				selectorType: $scope.selectorType,
				identifierPreferences: prefs,
				customScan: $scope.customScan,
				searchDepth: $scope.searchDepth,
				objectIndex:  $scope.objectIndex
			});

			$state.go('projectContext');
		}

		$scope.cancelEdit = function()
		{
			$state.go('projectContext');
		}

		$scope.addIdentifierAttribute = function ()
		{
			$scope.identifierAttributes.push({});
		}

		$scope.removeAttribute = function (attrs, attr)
		{
			var index = attrs.indexOf(attr);

			if (index >= 0) {
				attrs.splice(index, 1);
			}
		}

		$scope.addIdentifierMapping = function ()
		{
			$scope.identifierMappings.push({});
		}

		$scope.removeMapping = function (mappings, map)
		{
			var index = mappings.indexOf(map);

			if (index >= 0) {
				mappings.splice(index, 1);
			}
		}

		$scope.addIdentifierPreference = function ()
		{
			$scope.identifierPreferences.push({});
		}

		$scope.removePreference = function (identifierPrefs, id)
		{
			var index = identifierPrefs.indexOf(id);

			if (index >= 0) {
				identifierPrefs.splice(index, 1);
			}
		}
  }
]);
