testFlipInsight.factory('automationFrameworkService', ['$http', 'TenantService', 'API_URL',
    function ($http, TenantService, API_URL) {
        var automationFrameworkService = {};

        // Constants
        var api_base_url = API_URL.URL;

        var config = {
            headers: {
                'Content-Type': 'application/json'
            }
        }

        automationFrameworkService.getAutomationFrameworkItems = function () {
            return $http.get(api_base_url + '/api/tenant/' + TenantService.company + '/automation-framework');
        }

        automationFrameworkService.createAutomationFrameworkItem = function (item) {
            return $http.post(api_base_url + '/api/tenant/' + TenantService.company + '/automation-framework', item, config);
        }

        automationFrameworkService.getAutomationFrameworkItem = function (id) {
            return $http.get(api_base_url + '/api/tenant/' + TenantService.company + '/automation-framework/' + id);
        }

        automationFrameworkService.updateAutomationFrameworkItem = function (item) {
            return $http.put(api_base_url + '/api/tenant/' + TenantService.company + '/automation-framework/' + item.id, item, config);
        }

        automationFrameworkService.deleteAutomationFrameworkItem = function (id) {
            return $http.delete(api_base_url + '/api/tenant/' + TenantService.company + '/automation-framework/' + id);
        }

        return automationFrameworkService;
    }
]);
