testFlipInsight.service('fileService', ['$state', 'TenantService', '$http', 'API_URL',
  function fileService($state, TenantService, $http, API_URL)
  {
    var fileService = {};

    fileService.getRootFiles = function ()
    {
        // file
        return $http.get(API_URL.URL +'/api/tenant/' + TenantService.company + '/file');
    }

    fileService.getRootFilesByReleaseId = function (release_id)
    {
        // file
        return $http.get(API_URL.URL +'/api/tenant/' + TenantService.company + '/release/' + release_id + '/file');
    }

    fileService.getFilesInFolder = function (parent_id)
    {
        // folder/{id}/files
        return $http.get(API_URL.URL +'/api/tenant/' + TenantService.company + '/folder/' + parent_id + '/files');
    }

    fileService.addNewFile = function (folder_id, file_obj)
    {
        var config = {headers : {'Content-Type': 'application/json'}};

        // folder/{id}/file
        return $http.post(API_URL.URL +'/api/tenant/' + TenantService.company + '/folder/' + folder_id + '/file', file_obj, config);
    }

    fileService.updateFile = function (file_obj)
    {
      var config = {
        headers : {
          'Content-Type': 'application/json'
        }
      }
        // folder/{id}/file

        return $http.put(API_URL.URL +'/api/tenant/' + TenantService.company + '/file', file_obj);
    }

    fileService.deleteFile = function (file_id)
    {
        // file/id
        return $http.delete(API_URL.URL +'/api/tenant/' + TenantService.company + '/file/' + file_id);
    }

    return fileService;
  }
]);
