testFlipInsight.service('folderService', ['$state', 'TenantService', '$http', 'API_URL',
  function folderService($state, TenantService, $http, API_URL)
  {
    var folderService = {};

    folderService.getRootFolders = function ()
    {
      // folder
      return $http.get(API_URL.URL +'/api/tenant/' + TenantService.company + '/folder');
    }

    folderService.getRootFoldersByRelease = function (release_id)
    {
      // folder
      return $http.get(API_URL.URL +'/api/tenant/' + TenantService.company + '/release/' + release_id + '/folder');
    }

    folderService.getFolderById = function (id)
    {
      // folder
      return $http.get(API_URL.URL +'/api/tenant/' + TenantService.company + '/folder/' + id);
    }

    folderService.getSubFolders = function (parent_id)
    {
      // folder/{parent_id}/folders
      return $http.get(API_URL.URL +'/api/tenant/' + TenantService.company + '/folder/' + parent_id + '/folders');
    }

    folderService.addNewFolder = function (folder_obj)
    {
      var config = {
        headers : {
          'Content-Type': 'application/json'
        }
      }

      // folder
      return $http.post(API_URL.URL +'/api/tenant/' + TenantService.company + '/folder', folder_obj, config);

    }

    folderService.updateFolder = function (folder_obj)
    {
      var config = {
        headers : {
          'Content-Type': 'application/json'
        }
      }

        // folder
        return $http.put(API_URL.URL +'/api/tenant/' + TenantService.company + '/folder', folder_obj, config);

    }

    folderService.deleteFolder = function (folder_id)
    {
        // folder/{id}
        return $http.delete(API_URL.URL +'/api/tenant/' + TenantService.company + '/folder/' + folder_id);
    }

    return folderService;
  }
]);
