testFlipInsight.service('pageCollectionService', ['$state', 'TenantService', '$http', 'API_URL',
  function fileService($state, TenantService, $http, API_URL)
  {
    var pageCollectionService = {};

    pageCollectionService.getPageCollection = function (col_id)
    {
      return $http.get(API_URL.URL +'/api/tenant/' + TenantService.company + '/page-collection/' + col_id);
    }

    pageCollectionService.getPageCollectionsByNameAndRelease = function (col_name, col_release)
    {
      return $http.get(API_URL.URL +'/api/tenant/' + TenantService.company + '/project/release/' + col_release + '/page-collection/' + col_name);
    }

    pageCollectionService.savePageCollection = function (col_obj)
    {
      var config = {
        headers : {
          'Content-Type': 'application/json'
        }
      }

      return $http.post(API_URL.URL +'/api/tenant/' + TenantService.company + '/page-collection', col_obj, config);
    }

    pageCollectionService.savePageCollectionAndCreateModule = function (folderId, releaseId, col_obj, createModule)
    {
      var config = {
        headers : {
          'Content-Type': 'application/json'
        }
      }

      if (createModule == null)
        createModule = false;

      if (folderId == null) {
        return $http.post(API_URL.URL +'/api/tenant/' + TenantService.company + '/project/release/' + releaseId + '/page-collection?createModel=' + createModule, col_obj, config);
      } else {
        return $http.post(API_URL.URL +'/api/tenant/' + TenantService.company + '/project/release/' + releaseId + '/folder/' + folderId + '/page-collection?createModel=' + createModule, col_obj, config);
      }
    }

    return pageCollectionService;
  }
]);
