/* Factory for interacting with Test Session service */
testFlipInsight.factory('TestProjectService', ['$http','TenantService','API_URL', 'authService',
  function ($http, TenantService, API_URL, authService) {
    var testProjectService = {};

    /* Get all projects */
    testProjectService.getAllProjects = function () {
      console.log("Calling getAllProjects using API URL - " + API_URL.URL);

      console.log("Calling auth service - " + authService.getIdToken());

      return $http.get(API_URL.URL +'/api/tenant/' + TenantService.company + '/project/');
    };

    /* Get gen names by project */
    testProjectService.getCustomTemplateFunctionNamesForProject = function (proj_id) {
      return $http.get(API_URL.URL +'/api/tenant/' + TenantService.company + '/project/' + proj_id + '/release/code-template/custom-functions/names');
    };

    /* Get project by id */
    testProjectService.getProjectById = function (proj_id) {
      return $http.get(API_URL.URL +'/api/tenant/' + TenantService.company + '/project/' + proj_id);
    };

    /* Delete project by id */
    testProjectService.deleteProjectById = function (proj_id) {
      return $http.delete(API_URL.URL +'/api/tenant/' + TenantService.company + '/project/' + proj_id);
    };

    /* Post project  */
    testProjectService.saveProject = function (proj_obj) {
      var config = {
				headers : {
					'Content-Type': 'application/json'
				}
			}

			return $http.post(API_URL.URL + '/api/tenant/' + TenantService.company + '/project', proj_obj, config);
    };

    /* Put project by id */
    testProjectService.updateProjectById = function (proj_obj, proj_id) {
      var config = {
        headers : {
          'Content-Type': 'application/json'
        }
      }

    return $http.put(API_URL.URL + '/api/tenant/' + TenantService.company + '/project/' + proj_id, proj_obj, config);
  }


    return testProjectService;
}]);
