/* Factory for interacting with Test Session service */
testFlipInsight.factory('TestReleaseService', ['$http','TenantService','API_URL',
  function ($http, TenantService, API_URL) {
    var testReleaseService = {};

    /* Get release by project ID */
    testReleaseService.getAllReleasesByProjectID = function (proj_id) {
      return $http.get(API_URL.URL +'/api/tenant/' + TenantService.company + '/project/' + proj_id + '/release');
    };

    /* Get all releases */
    testReleaseService.getAllReleases = function () {
      return $http.get(API_URL.URL +'/api/tenant/' + TenantService.company + '/release');
    };

    /* Get release by id */
    testReleaseService.getReleaseById = function (release_id) {
      return $http.get(API_URL.URL +'/api/tenant/' + TenantService.company + '/release/' + release_id);
    };

    /* Post release */
    testReleaseService.createRelease = function (release_obj) {
      var config = {
				headers : {
					'Content-Type': 'application/json'
				}
			}

			return $http.post(API_URL.URL + '/api/tenant/' + TenantService.company + '/release', release_obj, config);
    };

    /* Delete release by id */
    testReleaseService.deleteRelease = function (release_id) {
      return $http.delete(API_URL.URL +'/api/tenant/' + TenantService.company + '/release/' + release_id);
    };

    /* Update release by id */
    testReleaseService.updateReleaseByID = function (release_obj, release_id) {
      var config = {
				headers : {
					'Content-Type': 'application/json'
				}
			}

			return $http.put(API_URL.URL + '/api/tenant/' + TenantService.company + '/release/' + release_id, release_obj, config);
    }

    return testReleaseService;
}]);
