
/* Factory for interacting with Test Activity service */
testFlipInsight.factory('TestSessionActivityService', ['$http','TenantService','API_URL',
  function ($http, TenantService, API_URL) {
    var testActivityService = {};

    testActivityService.getAllDistinctPageRefs = function () {
      return $http.get(API_URL.URL +'/api/tenant/' + TenantService.company + '/testactivity/collection/pages');
    };

    testActivityService.getAllWidthsByPageRef = function (pageId) {
      var config = {
        headers : {
          'Content-Type': 'application/json'
        }
      }

      return $http.post(API_URL.URL +'/api/tenant/' + TenantService.company + '/testactivity/collection/page/width', pageId, config);
    };


    testActivityService.getAllActivityByPageRef = function (pageId) {
      var config = {
        headers : {
          'Content-Type': 'application/json'
        }
      }

      return $http.post(API_URL.URL +'/api/tenant/' + TenantService.company + '/testactivity/collection/page', pageId, config);
    };

    testActivityService.getAllActivityByPageRefAndPageWidth = function (pageId, pageWidth) {
      var config = {
        headers : {
          'Content-Type': 'application/json'
        }
      }


      return $http.post(API_URL.URL +'/api/tenant/' + TenantService.company + '/testactivity/collection/page/' + pageWidth, pageId, config);
    };

    /* Get all test activities by session id */
    testActivityService.getAllTestActivitiesBySessionID = function (session_id) {
      return $http.get(API_URL.URL +'/api/tenant/' + TenantService.company + '/session/' + session_id + '/testactivity');
    };

    /* Get all test activity */
    testActivityService.getAllTestActivities = function () {
      return $http.get(API_URL.URL +'/api/tenant/' + TenantService.company + '/testactivity');
    };

    /* Get test activity by ID */
    testActivityService.getTestActivitiesByID = function (activity_id) {
      return $http.get(API_URL.URL +'/api/tenant/' + TenantService.company + '/testactivity/' + activity_id);
    };


    /* Post single testactivity */
    testActivityService.saveTestActivity = function (activity_object) {
			var config = {
				headers : {
					'Content-Type': 'application/json'
				}
			}

			return $http.post(API_URL.URL + '/api/tenant/' + TenantService.company + '/testactivity', activity_object, config);
    };

    /* Post collection of test activities */
    testActivityService.saveTestActivityCollection = function (activity_object_list) {
			var config = {
				headers : {
					'Content-Type': 'application/json'
				}
			}

			return $http.post(API_URL.URL + '/api/tenant/' + TenantService.company + '/testactivity/collection/Async', activity_object_list, config);
    };

    /* Remove test activity by ID */
    testActivityService.deleteTestActivityByID = function (activity_id) {
      return $http.delete(API_URL.URL +'/api/tenant/' + TenantService.company + '/testactivity/' + activity_id);
    };

    /* Update test activity by ID */
    testActivityService.updateTestActivityByID = function (activity_object, act_id) {
      var config = {
				headers : {
					'Content-Type': 'application/json'
				}
			}

			return $http.put(API_URL.URL + '/api/tenant/' + TenantService.company + '/testactivity/' + act_id, activity_object, config);
    }

    return testActivityService;
  }
]);
