/* Factory for interacting with Test Session service */
testFlipInsight.factory('TestSessionService', ['$http','TenantService', 'API_URL',
  function ($http, TenantService, API_URL) {
    var testSessionService = {};

    /* List of test sessions by release ID */
    testSessionService.allTestSessionsByReleaseID = function (release_id) {
      return $http.get(API_URL.URL +'/api/tenant/' + TenantService.company + '/release/' + release_id + '/session');
    };

    /* List of test sessions by project ID */
    testSessionService.allTestSessionsByProjectID = function (project_id) {
      return $http.get(API_URL.URL +'/api/tenant/' + TenantService.company + '/project/' + project_id + '/session');
    };

    /* List of all test session */
    testSessionService.allTestSessions = function () {

      return $http.get(API_URL.URL +'/api/tenant/' + TenantService.company + '/session');
    };

    /* Test session by ID */
    testSessionService.testSessionByID = function (session_id) {
      return $http.get(API_URL.URL +'/api/tenant/' + TenantService.company + '/session/' + session_id);
    };

    /* Post API Session */
    testSessionService.createTestSession = function (session_obj) {
			var config = {
				headers : {
					'Content-Type': 'application/json'
				}
			}

			return $http.post(API_URL.URL + '/api/tenant/' + TenantService.company + '/session', session_obj, config);
    };

    /* Delete Session by ID */
    testSessionService.deleteTestSession = function (session_id) {
      return $http.delete(API_URL.URL +'/api/tenant/' + TenantService.company + '/session/' + session_id);
    };

    return testSessionService;
}]);
