String.prototype.trunc = String.prototype.trunc ||
      function(n){
          return (this.length > n) ? this.substr(0, n-1) + '&hellip;' : this;
      };

 var englishBuilder = {
	buildClickText : function(cur_element, classifier_hash, x_path)
	{
		var text = "Click ";

		// Determine tag type - button, link
		if (cur_element.tagName.toLowerCase() == 'a') {
			text += "link ";
		} else if (cur_element.tagName.toLowerCase() == 'button') {
			text += "button ";
		} else if (cur_element.tagName.toLowerCase() == 'img') {
      text += "image ";
    } else if (cur_element.tagName.toLowerCase() == 'label') {
      text += "label ";
    } else if (cur_element.tagName.toLowerCase() == 'input') {
      if (cur_element.type != "text" && cur_element.type != "email")
        text += cur_element.type + " input ";
      else
        text += "input ";
    } else {
      text += "element ";
    }

		// Determine readable url by given tagName
    var element_text = null;
    if (cur_element.tagName.toLowerCase() == 'img') {
      // imgs may have alt text
      element_text = "'" + cur_element.alt + "'";
    } else if (cur_element.tagName.toLowerCase() == 'input') {
      element_text = englishBuilder.buildLabelForInput(cur_element);
    }

    // Generic tag text english translation
    if (element_text == null || element_text.trim() == '') {
  		element_text = cur_element.textContent.trim();
  		if (element_text != null && element_text != '') {
  			element_text = "'" + element_text + "'";
  		} else {
  			element_text = " with xPath '" + x_path + "'";
  		}
    }


		text += element_text;

		return text.trunc(200);
	},

  buildSelectParamText  : function(cur_element, classifier_hash, xpath)
	{
    var text = "Select option '[param]";

    // 1) attempt get name from label
    var element_label = englishBuilder.funcLabelForElement(cur_element);

    // 2) attempt get name .name
    if ((!element_label) || element_label == '') {
      element_label = cur_element.name;
    }

    // 3) Last resort generic name
		if ((!element_label) || element_label == '') {
			text += "' from dropdown";
		} else {
			text += "' from dropdown '" + element_label + "'";
		}

		text += "'";

		return text.trunc(200);
  },

	buildSelectText : function(cur_element, classifier_hash, xpath)
	{
		var text = "Select option '" + cur_element.options[cur_element.selectedIndex].text;

    // 1) attempt get name from label
    var element_label = englishBuilder.funcLabelForElement(cur_element);

    // 2) attempt get name .name
    if ((!element_label) || element_label == '') {
      element_label = cur_element.name;
    }

    // 3) Last resort generic name
		if ((!element_label) || element_label == '') {
			text += "' from dropdown";
		} else {
			text += "' from dropdown '" + element_label + "'";
		}

		text += "'";

		return text.trunc(200);
	},

  buildKeyDownParamText : function (cur_element, classifier_hash, xpath, key_code)
	{
    var text = "Press key '[param]' into input ";

		var element_label = englishBuilder.funcLabelForElement(cur_element);
		if (element_label == '') {
			text += "with xPath '" + xpath + "'";
		} else {
			text += " '" + element_label + "'";
		}

		text += "'";

		return text.trunc(200);
  },

	buildKeyDownText : function (cur_element, classifier_hash, xpath, key_code)
	{
		var text = "Press key '" + key_code + "' into input ";

		var element_label = englishBuilder.funcLabelForElement(cur_element);
		if (element_label == '') {
			text += "with xPath '" + xpath + "'";
		} else {
			text += " '" + element_label + "'";
		}

		text += "'";

		return text.trunc(200);
	},

	buildSubmitText : function(cur_element, classifier_hash, x_path)
	{
		return "Submitting form";
	},

	buildEnterSearchText : function (cur_element, classifier_hash, x_path)
	{
		var text = "Enter search '" + cur_element.value + "' into ";

		var element_label = englishBuilder.funcLabelForElement(cur_element);
		if (element_label == '') {
			text += "input with xPath '" + x_path + "'";
		} else {
			text += cur_element.tagName + " '" + element_label + "'";
		}

		text += "'";

		return text.trunc(200);
	},

  buildKeyPressParamText : function(cur_element, classifier_hash, x_path)
	{
    var text = "Enter text '[param]' into ";

    var element_text = englishBuilder.buildLabelForInput(cur_element);
		if (element_text != null & element_text != '') {
			text += element_text;
		} else {
      text += "input with xPath '" + x_path + "'";
		}

		text += "'";

		return text.trunc(200);
  },

	buildKeyPressText : function(cur_element, classifier_hash, x_path)
	{
		var text = "Enter text '" + cur_element.value + "' into ";

    var element_text = englishBuilder.buildLabelForInput(cur_element);
		if (element_text != null & element_text != '') {
			text += element_text;
		} else {
      text += "input with xPath '" + x_path + "'";
		}

		text += "'";

		return text.trunc(200);
	},

	buildDragCode : function (cur_element, classifier_hash, item_path, drop_path)
	{
		return "Dragging and drop Item";
	},

  buildLabelForInput : function (cur_element) {
    // 1) try to get label text
    var labelText = englishBuilder.funcLabelForElement(cur_element);
    if (labelText && labelText != '')
      return labelText;

    // 2) try get value name coupling
    if (cur_element.type != null) {
      if (cur_element.type.toLowerCase() === "radio") {
        if (cur_element.value && cur_element.name) {
          return "'" + cur_element.value + "'" + " for " +  "'" + cur_element.name + "''";
        }
      }
    }

    // 3) get inner value if Submit
    if ((cur_element.type != null && cur_element.type.toLowerCase() === "submit") || cur_element.tagName.toLowerCase() === "button" ||  cur_element.tagName.toLowerCase() === "a" || screenScraper.isDescendant(cur_element, 'a') || screenScraper.isDescendant(cur_element, 'button')) {
      if (cur_element.textContent != null && cur_element.textContent != "") {
        return cur_element.textContent.trim(99);
      } else if (cur_element.value) {
        return cur_element.value;
      } else if (cur_element.title) {
        return cur_element.title;
      }
    }

    if (cur_element.getAttribute("formcontrolname") != null) {
      return cur_element.getAttribute("formcontrolname");
    }

    if (cur_element.name != null && cur_element.name !== "") {
        return cur_element.name;
    }

    if (cur_element.getAttribute("aria-label") != null) {
      return cur_element.getAttribute("aria-label");
    }

    // 3) Try to get placeholder
    if (cur_element.placeholder) {
      return cur_element.placeholder;
    }

    if (cur_element.textContent != null && cur_element.textContent != "") {
      return cur_element.textContent.trim(99);
    }

    return null;
  },

  elementLabelName : function(cur_element, x_path) {
    var text = "";

    var warning = false;

    var element_text = englishBuilder.buildLabelForInput(cur_element);

    if (element_text != null & element_text != '') {
      text = element_text;
    }  else {
      warning = true;
      text = "xPath: '" + x_path + "'";
    }

    return {value: text.trim(), warning: warning};
  },

	funcLabelForElement : function (element) {
		var label = $('label[for="' + element.id +  '"]');

		if (label != null) {
			return label.text();
		} else {
			return element.name;
		}
	}
};
