
/**
 * Store the request is sent.
 */
 var headerStore = {};

 var attachedDebug = {};


 function resetHeaderStore(tabId, frameId, type, requestId) {
    tabId = String(tabId);

    initializeHeaderStore(tabId, requestId);
}

function initializeHeaderStore(tabId, requestId) {
    tabId = String(tabId);
    if ((headerStore[tabId])  == undefined) {
        headerStore[tabId] = {isContentReady: false};
    }
    if ((headerStore[tabId][requestId] == undefined)) {
        headerStore[tabId][requestId] = {};
        headerStore[tabId][requestId].request = {};
        headerStore[tabId][requestId].response = {};
        headerStore[tabId][requestId].timeToFirstByte = {};
        headerStore[tabId][requestId].timeToHeadersReceived = {};
        headerStore[tabId][requestId].timeToComplete = {};
    }
}

function removeDebuggers() {
  // for (key_name in attachedDebug) {
        // chrome.debugger.detach({tabId: parseInt(key_name)});

        // attachedDebug[key_name] = false;
  // }
}

function onBeforeRequest(info) {
        resetHeaderStore(info.tabId, info.frameId, info.type, info.requestId);

        let requestId = String(info.requestId),
            tabId = String(info.tabId)

        // Prevent error when HSTS occurs
        if (info.requestHeaders == null || info.requestHeaders == undefined) {
            info.requestHeaders = [];
        }
        headerStore[tabId][requestId].request = info;

        if (attachedDebug[info.tabId])
          return;


        attachedDebug[info.tabId] = true;
        // chrome.debugger.attach({tabId:info.tabId}, "1.2")
        // chrome.debugger.sendCommand({ tabId:info.tabId }, "Network.enable");
        // chrome.debugger.onEvent.addListener(onEvent);
}
/*
function onEvent(debuggeeId, message, params) {
    if (message == "Network.responseReceived" && params.type.toLowerCase() == "xhr") {
      alert("onEvent " + JSON.stringify(params));

      chrome.debugger.sendCommand({
            tabId: debuggeeId.tabId
        }, "Network.getResponseBody", {
            "requestId": params.requestId
        }, function(response) {

            if (headerStore[debuggeeId.tabId][params.requestId]  == undefined)
              headerStore[debuggeeId.tabId][params.requestId] = {};

            if (headerStore[debuggeeId.tabId][params.requestId].response == undefined)
              headerStore[debuggeeId.tabId][params.requestId].response = {};

            headerStore[debuggeeId.tabId][params.requestId].response.message = response;

            addNewRRPair(params.requestId, headerStore[debuggeeId.tabId][params.requestId]);
        });
    }
}
*/
/**
 * store response before redirecting
 */
 function onBeforeRedirect(info) {
      let requestId = String(info.requestId),
          tabId = String(info.tabId)

      // Maybe the request was already removed from the queue
      if ((headerStore[tabId] == undefined) || (headerStore[tabId][requestId] == undefined)) {
          return;
      }


      // In case of redirects, there may already be data for this request, extend it.
      if (typeof headerStore[tabId][requestId].response === 'object') {
          headerStore[tabId][requestId].response = Object.assign(headerStore[tabId][requestId].response, info);
      } else {
          headerStore[tabId][requestId].response = info;
      }

      // Add it to list & save
      addNewRRPair(requestId, headerStore[tabId][requestId]);
}

/**
 * Store the timestamp when the request completes
 */
function onCompleted (info) {
    let requestId = String(info.requestId),
        tabId = String(info.tabId);

    // Maybe the request was already removed from the queue
    if ((headerStore[tabId] == undefined) || (headerStore[tabId][requestId] == undefined)) {
        return;
    }

    // Log time to complete the request
    if (headerStore[tabId][requestId].request != null)
      headerStore[tabId][requestId].timeToComplete = {timeStamp: info.timeStamp - headerStore[tabId][requestId].request.timeStamp};

    // Extend the existing object with any new fields.
    if (typeof headerStore[tabId][requestId].response === 'object') {
        headerStore[tabId][requestId].response = Object.assign(headerStore[tabId][requestId].response, info);
    } else {
        headerStore[tabId][requestId].response= info;
    }

    // Results from cache don't have responseHeaders
    if ((headerStore[tabId][requestId].response.responseHeaders) == undefined) {
        headerStore[tabId][requestId].response.responseHeaders = [];
    }

    //  Add it to list & save
    addNewRRPair(requestId, headerStore[tabId][requestId]);

}
