var NodeObject = {
	inEdges: null,
	
	outEdges: null,
	
	name: "",
	
	description: "",
	
	action_item: null,
	
	x: 0,
	
	y: 0,
	
	ConstructObject : function (name, action_item, description = "")
	{
		var node_object = Object.create(NodeObject);

		node_object.name = name;

		node_object.action_item = action_item;
		
		node_object.inEdges = [];
		
 		node_object.outEdges = [];
		
		node_object.description = description;
		
		return node_object;
	},	
	
	ConnectionExistsTo : function(node) {
		for (var i = 0; i < this.outEdges.length; i++) {
			if (this.outEdges[i].outNode == node)
				return true;
		}
		
		return false;
	},
	
	IsDecision : function ()
	{
		return (this.inEdges.length > 1);
	},
	
	IsStartNode : function ()
	{
		return this.inEdges.length == 0;
	},
	
	IsEndNode : function ()
	{
		return this.outEdges.length == 0;		
	},
	
	GetInEdges : function()
	{
		return this.inEdges;
	},
	
	GetOutEdges : function()
	{
		return this.outEdges;
	},
		
	AddInEdge : function(edge)
	{
		this.inEdges.push(edge);
	},
	
	AddOutEdge : function(edge)
	{
		this.outEdges.push(edge);
	},
	
	RemoveInEdge : function(index)
	{
		this.inEdges.splice(index, 1);
	},
	
	RemoveOutEdge : function(index)
	{
		this.outEdges.splice(index, 1);		
	}
};