 var Recorder = {
	constructSelectEvent : function (event, action_type, dom_element, x_path, type, scanOption) {
		var action_code = codeBuilder.buildSelectCode(dom_element, action_type, x_path, dom_element.selectedIndex);

		if (action_code == null)
			return null;

		var eng_text = englishBuilder.buildSelectText(dom_element, action_type, x_path);
    var eng_param_text = englishBuilder.buildSelectParamText(dom_element, action_type, x_path);

    var locator = [];
    if (scanOption == "ServiceNow") {
        locator = globalSelector.buildServiceNowSelectorObject(dom_element);
    } else {
        locator = globalSelector.buildSelectorObject(dom_element);
    }

    if (locator.length == 0)
      return null;

		var action_event = ActionObject.ConstructObject(eng_text, eng_param_text, englishBuilder.elementLabelName(dom_element, x_path).value, window.location.href, document.title, getTime(), action_code, screenShotCapture.getScreenShotData(event), dom_element.outerHTML, cssBuilder.getCSS(dom_element), document.documentElement.outerHTML, cookieBuilder.getCookies(), locator);

		return action_event;
	},

	constructTypeEvent : function (event, action_type, dom_element, x_path, type, scanOption) {
		var action_code = codeBuilder.buildKeyPressCode(dom_element, action_type, x_path);

		if (action_code == null)
			return null;

		var eng_text = englishBuilder.buildKeyPressText(dom_element, action_type, x_path);
    var eng_param_text = englishBuilder.buildKeyPressParamText(dom_element, action_type, x_path);

    var locator = [];
    if (scanOption == "ServiceNow") {
        locator = globalSelector.buildServiceNowSelectorObject(dom_element);
    } else {
        locator = globalSelector.buildSelectorObject(dom_element);
    }

    if (locator.length == 0)
      return null;

		var action_event = ActionObject.ConstructObject(eng_text, eng_param_text, englishBuilder.elementLabelName(dom_element, x_path).value,  window.location.href, document.title, getTime(), action_code, screenShotCapture.getScreenShotData(event), dom_element.outerHTML, cssBuilder.getCSS(dom_element), document.documentElement.outerHTML, cookieBuilder.getCookies(), locator);

		return action_event;
	},

	constructClickEvent : function (event, action_type, dom_element, x_path, type, scanOption) {
		var action_code = null;//codeBuilder.buildClickCode(dom_element, action_type, x_path);

		var eng_text = englishBuilder.buildClickText(dom_element, action_type, x_path);
    var locator = [];
    if (scanOption == "ServiceNow") {
        if (dom_element.tagName.toLowerCase() !== "button")
          return;

        locator = globalSelector.buildServiceNowSelectorObject(dom_element);

        if (locator.length > 0)
          action_code = codeBuilder.buildClickCode(dom_element, action_type, locator[0].identifierValue);

    } else {
        locator = globalSelector.buildSelectorObject(dom_element);
        action_code = codeBuilder.buildClickCode(dom_element, action_type, x_path);
    }

    if (action_code == null || locator.length == 0)
      return null;

		var action_event = ActionObject.ConstructObject(eng_text, eng_text, englishBuilder.elementLabelName(dom_element, x_path).value, window.location.href, document.title, getTime(), action_code, screenShotCapture.getScreenShotData(event), dom_element.outerHTML, cssBuilder.getCSS(dom_element), document.documentElement.outerHTML, cookieBuilder.getCookies(), locator);

		return action_event
	},

	constructDragEvent : function (event, action_type, item_dom_element, item_x_path, drop_dom_element, drop_x_path, scanOption) {
		var action_code = codeBuilder.buildDragCode(drop_dom_element, action_type, item_x_path, drop_x_path);

		var eng_text = englishBuilder.buildDragCode(drop_dom_element, action_type, drop_x_path);

		if (action_code == null)
			return null;

    var locator = [];
    if (scanOption == "ServiceNow") {
        locator = globalSelector.buildServiceNowSelectorObject(dom_element);
    } else {
        locator = globalSelector.buildSelectorObject(dom_element);
    }

    if (locator.length == 0)
      return null;

		var action_event = ActionObject.ConstructObject(eng_text, eng_text, englishBuilder.elementLabelName(dom_element, x_path).value, window.location.href, document.title, getTime(), action_code, screenShotCapture.getScreenShotData(event), dom_element.outerHTML, cssBuilder.getCSS(dom_element), document.documentElement.outerHTML, cookieBuilder.getCookies(), locator);

		return action_event;
	},

	constructSubmitEvent : function(event, action_type, dom_element, x_path, type, scanOption) {
		var action_code = codeBuilder.buildSubmitCode(dom_element, action_type, x_path);

		var eng_text = englishBuilder.buildSubmitText(dom_element, action_type, x_path);

		if (action_code == null)
			return null;

    var locator = [];
    if (scanOption == "ServiceNow") {
        locator = globalSelector.buildServiceNowSelectorObject(dom_element);
    } else {
        locator = globalSelector.buildSelectorObject(dom_element);
    }

    if (locator.length == 0)
      return null;

		var action_event = ActionObject.ConstructObject(eng_text, eng_text, englishBuilder.elementLabelName(dom_element, x_path).value, window.location.href, document.title, getTime(), action_code, screenShotCapture.getScreenShotData(event), dom_element.outerHTML, cssBuilder.getCSS(dom_element), document.documentElement.outerHTML, cookieBuilder.getCookies(), locator);

		return action_event
	},

	constructKeyPressEvent : function (event, action_type, dom_element, x_path, key_code, type, scanOption) {
		var action_code = codeBuilder.buildKeyDownCode(x_path, key_code);

		var eng_text = englishBuilder.buildKeyDownText(dom_element, action_type, x_path, key_code); // TODO
    var eng_param_text = englishBuilder.buildKeyDownParamText(dom_element, action_type, x_path, key_code); // TODO

		if (action_code == null)
			return null;

    var locator = [];
    if (scanOption == "ServiceNow") {
        locator = globalSelector.buildServiceNowSelectorObject(dom_element);
    } else {
        locator = globalSelector.buildSelectorObject(dom_element);
    }

    if (locator.length == 0)
      return null;

		var action_event = ActionObject.ConstructObject(eng_text, eng_param_text, englishBuilder.elementLabelName(dom_element, x_path).value, window.location.href, document.title, getTime(), action_code, screenShotCapture.getScreenShotData(event), dom_element.outerHTML, cssBuilder.getCSS(dom_element), document.documentElement.outerHTML, cookieBuilder.getCookies(), locator);

		return action_event
	}
 };
