/*
	Classifier takes a javascript element
	and categorises it according to a discrete set of input types
	which we can use in selenium
	@return - text, radio, checkbox, file, submit, image, range, reset, select, a, element
*/
function classifier(element) {
  let hash = null;
  const tag = element.tagName.toLowerCase();
  if (tag === 'input') {
    switch (element.type) {
      case 'password':
        hash = { type: 'text', value: '***' };
        break;
      case 'radio':
        hash = { type: 'radio', value: element.value };
        break;
      case 'checkbox':
        hash = { type: 'checkbox', value: element.checked };
        break;
      case 'file':
        hash = { type: 'file', value: element.value };
        break;
	  case 'option':
		hash = { type: 'option', value: element.value };
		break;
	  case 'select':
		hash = { type: 'select', value: element.value };
		break;
      case 'email':
      case 'tel':
      case 'url':
      case 'number':
	  case 'textarea':
      case 'search':
      case 'text':
      case 'date':
      case 'datetime-local':
      case 'week':
      case 'month':
      case 'color':
        hash = { type: 'text', value: element.value };
        break;
      case 'submit':
      case 'image':
      case 'range':
      case 'reset':
        hash = { type: element.type };
        break;
      case 'hidden':
      default:
        break;
    }
  } else if (tag === 'textarea') {
    hash = { type: 'text', value: element.value };
  } else if (tag === 'select') {
    hash = { type: 'select', value: element.value };
  } else if (tag === 'option') {
    hash = { type: 'option', value: element.value };
  } else if (tag === 'a') {
    hash = { type: 'a', value: element.href };
  } else if (tag === 'form') {
    hash = { type: 'form', value: element.href };
  } else if (tag === 'label') {
    hash = {type: 'label'}
  } else {
	  hash = { type: 'element', value: element.value };
  }

  return hash;
}

if (typeof exports !== 'undefined') exports.classifier = classifier;
