// Start recording
document.addEventListener("start_record", function(data) {
	chrome.runtime.sendMessage({ operation: 'record'});
});

// Stop recording
document.addEventListener("stop_record", function(data) {
	chrome.runtime.sendMessage({ operation: 'stop'});
});

document.addEventListener("pause_record", function(data) {
	chrome.runtime.sendMessage({ operation: 'pause'});
});

document.addEventListener("resume_record", function(data) {
	chrome.runtime.sendMessage({ operation: 'resume'});
});

// New session
document.addEventListener("new_session", function(data) {
	chrome.runtime.sendMessage({ operation: 'clear'});
});

// Upload session
document.addEventListener("upload_session_async", function(data) {
	var obj = { operation: 'upload_session_async', url: data.detail.url, apiKey: data.detail.apiKey, poolId: data.detail.poolId, releaseID: data.detail.releaseID, name: data.detail.name, source: data.detail.source, sourceLocation: data.detail.sourceLocation};

	if (data.detail.uploadState != undefined) {
		obj.uploadState = data.detail.uploadState;

		if (data.detail.uploadDesc != undefined)
			obj.uploadDesc = data.detail.uploadDesc;
	}

	chrome.runtime.sendMessage(obj);
});

document.addEventListener("upload_session_sync", function(data) {
	var obj = { operation: 'upload_session_sync', url: data.detail.url, apiKey: data.detail.apiKey, releaseID: data.detail.releaseID, name: data.detail.name, source: data.detail.source, sourceLocation: data.detail.sourceLocation};

	if (data.detail.uploadState != undefined) {
		obj.uploadState = data.detail.uploadState;

		if (data.detail.uploadDesc != undefined)
			obj.uploadDesc = data.detail.uploadDesc;
	}


	chrome.runtime.sendMessage(obj);
});
