// var urlBase = "http://localhost:8080";
// var urlBase = "http://137.116.119.97:8080";//http://192.168.0.15:8080";
// var urlBase = "http://192.168.0.29:8080";
var urlBase = "http://testinsightsprod-env-2.qbg2yi38f8.eu-west-1.elasticbeanstalk.com";

String.prototype.trim = function (length) {
  return this.length > length ? this.substring(0, length) : this;
}

var ActivityUploader = {

  // sourceLocation -> Automation
  createNewSessionApiKeySync : function (activityList, rrList, consoleList, sessionName, source, sourceLocation, release_id, pool_id, apiKey, uploadState, uploadDesc, url)
  {
    urlBase = url;

    ActivityUploader.createNewSessionApiKey(activityList, rrList, consoleList, sessionName, source, sourceLocation, release_id, pool_id, apiKey, uploadState, uploadDesc, true);
  },

  createNewSessionApiKeyAsync : function (activityList, rrList, consoleList, sessionName, source, sourceLocation, release_id, pool_id, apiKey, uploadState, uploadDesc, url)
  {
      urlBase = url;

      ActivityUploader.createNewSessionApiKey(activityList, rrList, consoleList, sessionName, source, sourceLocation, release_id, pool_id, apiKey, uploadState, uploadDesc, false);
  },

  createNewSessionApiKey : function (activityList, rrList, consoleList, sessionName, source, sourceLocation, release_id, pool_id, apiKey, uploadState, uploadDesc, sync)
  {
      // Create pool
      // Create journey
      var obj = {};
			obj.release = release_id;
			obj.title = sessionName;
			obj.description = "Source: " + source + " - Source Location: " + sourceLocation;
      obj.sourceLocation = source;
      obj.journeyPool = pool_id;
      obj.state = uploadState;
      obj.stateDescription = uploadDesc;

      $.ajax({
          url: urlBase + "/api/apikey/" + apiKey + "/journey/integrate",
          type: "POST",
          contentType : 'application/json; charset=utf-8',
          dataType: 'json',
          data: JSON.stringify(obj),
          success: function(response) {
              var journeyObj = response;

              ActivityUploader.createSession(activityList, rrList, consoleList, journeyObj.title, source, sourceLocation, journeyObj.id, release_id, apiKey, uploadState, uploadDesc, sync);
          },
          error: function(data){
            console.log("Error creating journey " + JSON.stringify(data));

            chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
              // Send message to current tab open to record
              chrome.tabs.sendMessage(tabs[0].id, {operation: "alert", data: "Error uploading journey"}, function(response) {
                  console.log(response);
               });
            });
          }
        });
  },

  createSession : function (activityList, rrList, consoleList, sessionName, source, sourceLocation, journey_id, release_id, apiKey, uploadState, uploadDesc, sync)
  {
      var obj = {};
      obj.journey = journey_id;
      obj.release = release_id;
      obj.title = sessionName;
      obj.sourceLocation = source;
      obj.description = "Automated test case recorded";
      obj.createdTimestamp = new Date().getTime();

      obj.state = uploadState;
      obj.stateDescription = uploadDesc;

      $.ajax({
              url: urlBase + "/api/apikey/" + apiKey + "/session",
              type: "POST",
              contentType : 'application/json; charset=utf-8',
              dataType: 'json',
              data: JSON.stringify(obj),
              success: function(response) {
                // Upload link
                ActivityUploader.createLink(response.id, source, sourceLocation, apiKey);

                // Upload activities
                ActivityUploader.uploadActivitiesApiKey(response.id, apiKey, activityList, rrList, consoleList, sync);
              },
              error: function(data){
                console.log("Error uploading activity " + JSON.stringify(data));

                chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
                  // Send message to current tab open to record
                  chrome.tabs.sendMessage(tabs[0].id, {operation: "alert", data: "Error uploading session"}, function(response) {
                      console.log(response);
                   });
                });
              }
            });
  },

  createLink : function (sessionId, source, sourceLocation, apiKey)
  {
      var obj = {};

      obj.linkType = "AutomationScript";
      obj.sourceId = source;
      obj.sourceLocation = sourceLocation;

      $.ajax({
              url: urlBase + "/api/apikey/" + apiKey + "/link",
              type: "POST",
              contentType : 'application/json; charset=utf-8',
              dataType: 'json',
              data: JSON.stringify(obj),
              success: function(response) {
                console.log("created link");

                // Bind session & link
                ActivityUploader.bindLinkToSession(sessionId, response.linkId, apiKey);

              },
              error: function(data){
                console.log("error creating link " + JSON.stringify(data));

              }
      });
  },

  bindLinkToSession : function (sessionId, linkId, apiKey)
  {
    $.ajax({
            url: urlBase + "/api/apikey/" + apiKey + "/link/" + linkId + "/session/" + sessionId,
            type: "POST",
            contentType : 'application/json; charset=utf-8',
            dataType: 'text',
            data: "{}",
            success: function(response) {
              console.log("binded link");
            },
            error: function(data){
              console.log("error binding link " + JSON.stringify(data));
            }
    });
  },

  uploadActivitiesApiKey: function (sessionId, apiKey, testActivity, testActivityRRPair, testActivityConsole, sync)
  {
    // 1) Upload RR pairs
    var rrList = [];
    for(var rrID = 0; rrID < testActivityRRPair.length; rrID++) {
        var rrPair = {};

        var curRRPair = JSON.parse(testActivityRRPair[rrID]);

				if (curRRPair.request == undefined) {
					 continue;
				 }

          rrPair.requestMessage = {};
  				rrPair.requestMessage.method = curRRPair.request.method.trim(40);

  				if (curRRPair.request.requestBody != undefined) {
  					rrPair.requestMessage.requestBody = JSON.stringify(curRRPair.request.requestBody.raw);
  				} else {
  					rrPair.requestMessage.requestBody = "";
  				}
  				rrPair.requestMessage.type = curRRPair.request.type.trim(100);
  				rrPair.requestMessage.url = curRRPair.request.url;
  				rrPair.requestMessage.requestHeaders = JSON.stringify(curRRPair.request.requestHeaders);

  				rrPair.responseMessage = {};
  				rrPair.responseMessage.fromCache = curRRPair.response.fromCache;
  				rrPair.responseMessage.ip = curRRPair.response.ip;
  				rrPair.responseMessage.method = curRRPair.response.method.trim(100);
  				rrPair.responseMessage.statusCode = curRRPair.response.statusCode;
  				rrPair.responseMessage.statusLine = curRRPair.response.statusLine.trim(100);
  				rrPair.responseMessage.type = curRRPair.response.type.trim(100);
  				rrPair.responseMessage.url = curRRPair.response.url;
  				rrPair.responseMessage.responseHeaders = JSON.stringify(curRRPair.response.responseHeaders);
  				rrPair.responseMessage.message = JSON.stringify(curRRPair.response.message);
  				rrPair.responseMessage.timeStamp = Math.round(curRRPair.response.timeStamp);

  				rrPair.messageDuration = curRRPair.timeToComplete.timeStamp;

  				rrPair.session = sessionId;

        rrList.push(rrPair);
    }

    $.ajax({
            url: urlBase + "/api/apikey/" + apiKey + "/testactivity/rrpair",
            type: "POST",
            contentType : 'application/json; charset=utf-8',
            dataType: 'text',
            data: JSON.stringify(rrList),
            success: function(response) {
                console.log("Test activity rr uploaded");
            },
            error: function(data){
              console.log("Error uploading rr activity" + JSON.stringify(data));
            }
          });

    // 2) Upload console
    for (var i = 0; i < testActivityConsole.length; i++) {
        testActivityConsole[i].session = sessionId;
    }

    $.ajax({
            url: urlBase + "/api/apikey/" + apiKey + "/testactivity/console",
            type: "POST",
            contentType : 'application/json; charset=utf-8',
            dataType: 'text',
            data: JSON.stringify(testActivityConsole),
            success: function(response) {
                console.log("Test activity console uploaded");
            },
            error: function(data){
              console.log("Error uploading console activity" + JSON.stringify(data));
            }
          });

    // 3) Upload recording
    var data = [];

    for (var i = 0; i < testActivity.length; i++) {
      var curElement = testActivity[i];

      // If current element is new URL after a switch tab event then continue;
      if (i >= 1 && data.length >= 1) {
        // alert("curElement.code.type " + curElement.code.type.trim() + "" data[data.length - 1].objectInteractionType.trim())
        if (curElement.code.type != undefined && curElement.code.type.trim() === Code_Actions.Event_New_URL.trim()) {
          if (data[data.length - 1].objectInteractionType.trim() === Code_Actions.Event_Switch_Tab.trim()) {
              continue;
          }
        }
      }


      var obj = {};
      obj.session = sessionId;
      obj.actionType = curElement.type;
      obj.actionDescription = curElement.english; // English description
      obj.paramertisedActionDescription = curElement.paramEnglish;
      obj.tagName = curElement.tagEnglishName.trim(100);
      obj.associatedCode = seleniumWebdriverJava.create_snippet(testActivity[i]); // Code
      obj.dateTime = testActivity[i].time_stamp; // Time
      obj.objectId = curElement.code.elem; // Element ID (xpath)
      obj.objectInteractionType = curElement.code.type.trim(100);
      obj.objectType = "na"; // TODO - Tag type
      obj.objectValue = curElement.code.value; // Obj value
      obj.pageRef = curElement.url; // Page reference
      obj.pageTitle = curElement.title; // page title
      obj.htmlDOM = curElement.domHTML; // DOM html
			obj.cssDOM = JSON.stringify(curElement.domCSS); // DOM css
      obj.htmlPage = curElement.htmlPage;
			obj.associatedCookies = [];
      obj.identifiers = curElement.elemIdentifiers;

      if (curElement.action_img != undefined && curElement.action_img.screenshot != undefined)
        obj.image = curElement.action_img.screenshot.replace(/^data:image\/(png|jpg|jpeg);base64,/, '');

      obj.actionRegion = {};
      if (curElement.action_img != null && curElement.action_img != undefined) {
        obj.actionRegion.viewportStartXPos = parseInt(curElement.action_img.viewportStartXPos);
        obj.actionRegion.viewportStartYPos = parseInt(curElement.action_img.viewportStartYPos);
        obj.actionRegion.viewportWidth = parseInt(curElement.action_img.viewportWidth);
        obj.actionRegion.viewportHeight = parseInt(curElement.action_img.viewportHeight);
        obj.actionRegion.actionLocalXPos = parseInt(curElement.action_img.actionBoundingLocalXPos);
        obj.actionRegion.actionLocalYPos = parseInt(curElement.action_img.actionBoundingLocalYPos);
        obj.actionRegion.actionGlobalXPos = parseInt(curElement.action_img.actionBoundingGlobalXPos);
        obj.actionRegion.actionGlobalYPos = parseInt(curElement.action_img.actionBoundingGlobalYPos);
        obj.actionRegion.globalPageWidth = parseInt(curElement.action_img.globalPageWidth);
        obj.actionRegion.globalPageHeight = parseInt(curElement.action_img.globalPageHeight);
        obj.actionRegion.width = parseInt(curElement.action_img.width);
        obj.actionRegion.height = parseInt(curElement.action_img.height);
      }

      data.push(obj);
    }

    var api_url = "";
    if (sync) {
      api_url =  urlBase + "/api/apikey/" + apiKey + "/testactivity/collection/Sync"
    } else {
      api_url =  urlBase + "/api/apikey/" + apiKey + "/testactivity/collection/Async"
    }

    $.ajax({
            url:api_url,
            type: "POST",
            contentType : 'application/json; charset=utf-8',
            dataType: 'text',
            data: JSON.stringify(data),
            success: function(response) {
              if (sync) {
                $.ajax({
                        url: urlBase + "/api/apikey/" + apiKey + "/expected-result/execute/session/" + sessionId,
                        type: "GET",
                        contentType : 'application/json; charset=utf-8',
                        dataType: 'text',
                        success: function(response) {
                          console.log("Test activity uploaded");

                          chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
                            // Send message to current tab open to record
                            chrome.tabs.sendMessage(tabs[0].id, {operation: "alert", data: "Test activity uploaded"}, function(response) {
                    				    console.log(response);
                    			   });
                          });
                        },
                        error: function(data) {
                          console.log("ERROR " + data);
                          console.log("ERROR " + JSON.stringify(data));

                        }
                });
              } else {
                chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
                  // Send message to current tab open to record
                  chrome.tabs.sendMessage(tabs[0].id, {operation: "alert", data: "Test activity uploaded"}, function(response) {
                      console.log(response);
                   });
                });
              }
            },
            error: function(data){
              console.log("Error uploading activity " + JSON.stringify(data));
              chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
                // Send message to current tab open to record
                chrome.tabs.sendMessage(tabs[0].id, {operation: "alert", data: "Error uploading activity"}, function(response) {
                    console.log(response);
                 });
              });
            }
          });
  }
};
